"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _AbstractMethod2 = _interopRequireDefault(require("./AbstractMethod"));

var _paramsValidator = require("./helpers/paramsValidator");

var _DataManager = _interopRequireDefault(require("../../data/DataManager"));

var _BlockchainLink = require("../../backend/BlockchainLink");

var SetProxy = /*#__PURE__*/function (_AbstractMethod) {
  (0, _inheritsLoose2["default"])(SetProxy, _AbstractMethod);

  function SetProxy() {
    return _AbstractMethod.apply(this, arguments) || this;
  }

  var _proto = SetProxy.prototype;

  _proto.init = function init() {
    this.requiredPermissions = [];
    this.useDevice = false;
    this.useUi = false;
    (0, _paramsValidator.validateParams)(this.payload, [{
      name: 'useOnionLinks',
      type: 'boolean'
    }]);
  };

  _proto.run = /*#__PURE__*/function () {
    var _run = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _DataManager$getSetti, proxy, useOnionLinks, isChanged;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _DataManager$getSetti = _DataManager["default"].getSettings(), proxy = _DataManager$getSetti.proxy, useOnionLinks = _DataManager$getSetti.useOnionLinks;
              isChanged = proxy !== this.payload.proxy || useOnionLinks !== this.payload.useOnionLinks;

              if (!isChanged) {
                _context.next = 7;
                break;
              }

              _DataManager["default"].settings.proxy = this.payload.proxy;
              _DataManager["default"].settings.useOnionLinks = this.payload.useOnionLinks;
              _context.next = 7;
              return (0, _BlockchainLink.reconnectAllBackends)();

            case 7:
              return _context.abrupt("return", {
                message: 'Success'
              });

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function run() {
      return _run.apply(this, arguments);
    }

    return run;
  }();

  return SetProxy;
}(_AbstractMethod2["default"]);

exports["default"] = SetProxy;