"use strict";

exports.__esModule = true;
exports.transformCollateralInput = exports.transformInput = void 0;

var _paramsValidator = require("./paramsValidator");

var _pathUtils = require("../../../utils/pathUtils");

var transformInput = function transformInput(input) {
  (0, _paramsValidator.validateParams)(input, [{
    name: 'prev_hash',
    type: 'string',
    required: true
  }, {
    name: 'prev_index',
    type: 'number',
    required: true
  }]);
  return {
    input: {
      prev_hash: input.prev_hash,
      prev_index: input.prev_index
    },
    path: input.path ? (0, _pathUtils.validatePath)(input.path, 5) : undefined
  };
};

exports.transformInput = transformInput;

var transformCollateralInput = function transformCollateralInput(collateralInput) {
  (0, _paramsValidator.validateParams)(collateralInput, [{
    name: 'prev_hash',
    type: 'string',
    required: true
  }, {
    name: 'prev_index',
    type: 'number',
    required: true
  }]);
  return {
    collateralInput: {
      prev_hash: collateralInput.prev_hash,
      prev_index: collateralInput.prev_index
    },
    path: collateralInput.path ? (0, _pathUtils.validatePath)(collateralInput.path, 5) : undefined
  };
};

exports.transformCollateralInput = transformCollateralInput;