"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getAbortController = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _events = _interopRequireDefault(require("events"));

/* eslint-disable max-classes-per-file */
// inspired by https://github.com/southpolesteve/node-abort-controller/
// nodejs AbortController is available since version 15, currently we are using 12.
var AbortSignal = /*#__PURE__*/function () {
  function AbortSignal() {
    (0, _defineProperty2["default"])(this, "aborted", false);
    this.eventEmitter = new _events["default"]();
  }

  var _proto = AbortSignal.prototype;

  _proto.toString = function toString() {
    return '[object AbortSignal]';
  };

  _proto.removeEventListener = function removeEventListener(name, handler) {
    this.eventEmitter.removeListener(name, handler);
  };

  _proto.addEventListener = function addEventListener(name, handler) {
    this.eventEmitter.on(name, handler);
  };

  _proto.dispatchEvent = function dispatchEvent(type) {
    this.eventEmitter.emit(type, {
      type: type,
      target: this
    });
  };

  return AbortSignal;
}();

var AbortControllerFallback = /*#__PURE__*/function () {
  function AbortControllerFallback() {
    this.signal = new AbortSignal();
  }

  var _proto2 = AbortControllerFallback.prototype;

  _proto2.abort = function abort() {
    if (this.signal.aborted) return;
    this.signal.dispatchEvent('abort');
    this.signal.aborted = true;
  };

  _proto2.toString = function toString() {
    return '[object AbortController]';
  };

  return AbortControllerFallback;
}();

// AbortController part of node since v15
var getAbortController = function getAbortController() {
  return typeof AbortController !== 'undefined' ? new AbortController() : new AbortControllerFallback();
};

exports.getAbortController = getAbortController;